import es, cfglib, popuplib, path, random, services, playerlib
from es import server_var

map_file = es.ServerVar("eventscripts_currentmap")
addonDir = path.path(es.getAddonPath('snow'))
locations_path = addonDir.joinpath('maps/%s.txt' % map_file)
number = 0

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/snow.cfg')
config.text("************************")
config.text("         Snow           ")
config.text("************************")
snow_basespread   = config.cvar("snow_basespread",   100, "Size of the ring when it spawns to spread..")
snow_spreadspeed   = config.cvar("snow_spreadspeed",   100, "Speed it spreads")
snow_windspeed  = config.cvar("snow_windspeed",   0, "Sets wind eg. makes it dift sidewards as it goes down")
snow_speed   = config.cvar("snow_speed",   10, "Rate it falls")
snow_time   = config.cvar("snow_time",   500, "Amount of time the snow last before respawns")
snow_twist   = config.cvar("snow_twist",   0, "Twists it way down")
snow_colour   = config.cvar("snow_colour",   '255 255 255', "Colour of snow eg. White is default")
config.text("\n")
config.text("************************")
config.text("   Advanced Settings    ")
config.text("************************")
snow_initial   = config.cvar("snow_initial",   0, "I Don't know what this does... So wouldn't change it")
snow_startsize   = config.cvar("snow_startsize",   1.000, "The start size")
snow_endsize   = config.cvar("snow_endsize",   1.000, "The end size it grows to")
snow_rate   = config.cvar("snow_rate",   550, "Rate of something")

config.write()

info = es.AddonInfo()
info.name     = "Snow"
info.version  = "0.3"
info.url      = "None"
info.basename = "sic_snow"
info.author   = "sicman_adrian"
es.ServerVar('sic_snow', info.version, 'Creates Snow middle of map').makepublic()



def load():
    config.execute()
    snow_admin = popuplib.create('snow_admin')
    snow_admin.addline('SIC-Snow')
    snow_admin.addline('----------------------')
    snow_admin.addline('->1. Add My Current Location')
    snow_admin.addline('----------------------')
    snow_admin.menuselect = snow_admin_menuselect
    loadlocations(locations_path)
    setup_auth()
    if not es.exists("command", "!snow"):
        es.regsaycmd("!snow", "snow/popup")

def unload():
    if es.exists('saycommand', '!snow'):
        es.unregsaycmd('!snow')

def es_map_start(ev):
    map_file = es.ServerVar("eventscripts_currentmap")
    locations_path = addonDir.joinpath('maps/%s.txt' % map_file)
    loadlocations(locations_path)

def loadlocations(locations_path):
    if not map_file == "":
        if locations_path.isfile():
            fileHandle = open(locations_path, 'r')
            locations_list = [x.strip() for x in fileHandle.readlines()]
            fileHandle.close()
            global location
            location = [x.split(' ', 3) for x in locations_list]
    else:
        locations_path.touch()

def round_start(ev):
    effect()

def effect():
    global number
    for spot in location:
        number += 1
        userid = random.choice(playerlib.getUseridList('#all'))
        es.server.queuecmd('es_xgive %s env_Smokestack' % (userid))
        es.server.queuecmd('es est_setentname server_var(eventscripts_lastgive) snow_%s'% number)
        es.server.queuecmd('es_fire %s snow_%s addoutput "basespread %s"' % (userid, number, snow_basespread))
        es.server.queuecmd('es_fire %s snow_%s addoutput "spreadspeed %s"' % (userid, number, snow_spreadspeed))
        es.server.queuecmd('es_fire %s snow_%s addoutput "WindSpeed %s"' % (userid, number, snow_windspeed))
        es.server.queuecmd('es_fire %s snow_%s addoutput "initial %s"' % (userid, number, snow_initial))
        es.server.queuecmd('es_fire %s snow_%s addoutput "speed %s"' % (userid, number, snow_speed))
        es.server.queuecmd('es_fire %s snow_%s addoutput "startsize %s"' % (userid, number, snow_startsize))
        es.server.queuecmd('es_fire %s snow_%s addoutput "endsize %s"' % (userid, number, snow_endsize))
        es.server.queuecmd('es_fire %s snow_%s addoutput "rate %s"' % (userid, number, snow_rate))
        es.server.queuecmd('es_fire %s snow_%s addoutput "jetlength %s"' % (userid, number, snow_time))
        es.server.queuecmd('es_fire %s snow_%s addoutput "twist %s"' % (userid, number, snow_twist))
        es.server.queuecmd('es_fire %s snow_%s addoutput "SmokeMaterial particle/snow"' % (userid, number))
        es.server.queuecmd('es_fire %s snow_%s addoutput "angles 180 0 0"' % (userid, number))
        es.server.queuecmd('es_fire %s snow_%s addoutput "rendermode 18"' % (userid, number))
        es.server.queuecmd('es_fire %s snow_%s addoutput "renderamt 180"' % (userid, number))
        es.server.queuecmd('es_fire %s snow_%s addoutput "rendermode 18"' % (userid, number))
        es.server.queuecmd('es_fire %s snow_%s addoutput "rendercolor %s"' % (userid, number, snow_colour))
        es.server.queuecmd('es_fire %s snow_%s addoutput "origin %s %s %s"' % (userid, number, spot[0], spot[1], spot[2]))
        es.server.queuecmd('es_fire %s snow_%s turnon' % (userid, number))

def snow_admin_menuselect(userid, choice, popupid):
    if choice == 1:
        myLocation = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin").split(",")
        snowlocation = "%s %s %s" % (myLocation[0], myLocation[1], myLocation[2])
        writetofile(map_file, snowlocation)
        es.tell(userid, '#multi', '#green[Sic-Snow] #lightgreen%s#green was Created ' % snowlocation)

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('snow_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'snow_admin')
    else:
        isAuthed = lambda x: False

def popup():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.send('snow_admin', userid)

def writetofile(map_file, snowlocation):
    mapFile = addonDir.joinpath('maps/%s.txt' % map_file)
    file = open(mapFile, "a")
    file.write(snowlocation + "\n")
    file.close()